]> git.sesse.net Git - backup.sh/blob - backup.sh
Reindent everything, so that we are not stuck with two differing indentation levels...
[backup.sh] / backup.sh
1 #!/bin/bash
2 # backup.sh
3
4 # Backup up Unix-like computers
5
6 # itk@samfundet.no
7 #
8 # This script was first checked into RCS in 2000, and has since backed up a few
9 # servers almost every day, whenever not broken.
10
11 # It's a bit peculiar, but quite effective. The following is worth keeping in
12 # mind when hacking:
13 #
14 # KISS. And by that I mean really simple. Only regular Unix commands, please
15 # (but GNU extensions are used and moreutils has to be installed).
16 #
17 # Because of the way we run this script from cron, informational logging goes
18 # to stderr and warnings and errors to stdout. This way, we get mail whenever
19 # stuff fails, and other output is redirected to the log file.
20
21 # The script is halfway Norwegian and halfway English. Newer modifications are
22 # in English, we should probably stick to that.
23
24 # The computer to backup.
25 computer=$1
26
27 # Configuration
28 LOCKFILE=/home/backup/backuprun.lockfile.$computer
29 confdir=/home/backup/conf/              # Configuration files
30 storagedir=/backup                      # Where we keep backups
31 maksantallfulle=3                       # Number of full backups
32 dagermellomfulle=30                     # Days between full backups
33 dagermellomfulleforfast=32              # Days between full backups for machines with fixed
34                                         # full-backup date (in case the fixed day gets missed)
35 DAY_OF_MONTH=`date "+%d" | sed s/^0//`  # from 1 to 31
36 DATE=`date "+%Y%m%d%H%M"`               #format: touch
37 DATEs=`date "+%Y-%m-%d %H:%M"`          #format: tar
38
39 # Exclude-pattern
40 exclude=$confdir/exclude
41 [ ! -f $exclude ] && printf "tmp\ncore\n" > $exclude
42
43 if [ -z "$computer" ]; then
44         echo "Usage: $0 COMPUTER"
45         exit 1
46 fi
47
48 # Die more or less gracefully (at least notify user)
49 die() {
50         echo `date`": Something nasty happened. Ending, and not deleting lockfile $LOCKFILE."
51         exit 1
52 }
53
54 # Trap C-c and kill
55 trap die SIGINT SIGTERM
56
57 # Don't start if we're already running
58 if [ -e $LOCKFILE ]; then
59         echo `date`": $LOCKFILE exists for pid `cat $LOCKFILE`, exiting."
60         echo `date`": $LOCKFILE exists for pid `cat $LOCKFILE`, exiting." >&2
61         exit 1
62 fi;
63 touch $LOCKFILE
64 echo $$ > $LOCKFILE
65
66 echo `date`": Backup run starting" >&2
67
68 umask 027
69
70
71 backup()
72 {
73         echo -n `date` >&2
74         printf " $computer: $computer:$filesystem $backuplevel backup\n" >&2
75
76         SNARFILE="${storagedir}/${computer}/${sfilesystem}/.incremental.snar"
77         incrementalsnar="/root/.backup/${sfilesystem}.snar"
78         if [ "$backuplevel" = "daglig" ]
79         then
80                 # If incremental backup, we need to copy the incremental status to $computer.
81                 # If it does not exist, whine a bit and then run date-based instead.
82                 if [ -s "$SNARFILE" ]; then
83                         if ! scp $SNARFILE root@$computer:$incrementalsnar; then
84                                 echo `date`" $computer: Could not copy .incremental.snar to $computer"
85                                 die
86                         fi
87                         lastcmd="--listed-incremental=$incrementalsnar --no-check-device"
88                 else
89                         echo `date`" $computer: Missing incremental.snar for $filesystem, doing date-based backup instead until next full backup" >&2
90                         incrementalsnar=""
91                         lastd=`cat ../.date`
92                         lastcmd="--newer='$lastd'"
93                 fi
94         else
95                 lastcmd="--listed-incremental=$incrementalsnar"
96         fi
97
98         # expand the exclude-path for use with tar
99         exf=`ssh root@$computer "ls ~/.backup/exclude"`
100
101         # We try to run tar on the remote computer
102         #    c create archive
103         #    C change to directory first
104         #    . where to start taring (see C)
105         #    $lastcmd only files newer than this
106         #    --one-file-system don't traverse file systems
107         #    --use-compress-program compress it using gzip or pigz
108         #    --exclude-from file to get exclusion pattern from
109         #    Pipe the stuff over ssh to ourselves, run pee to cat the contents to a
110         #    file and build a file list, respectivly.  
111         TARFILE=$DATE.tmp
112         TARCMD="ssh root@$computer \"nice -n 19 ionice -c3 tar --one-file-system --use-compress-program $compressor -cf - -C $filesystem . $lastcmd \
113                 --exclude-from=$exf\" | pee \"cat > $TARFILE\" \"tar tzvf -\""
114         echo `date`" $computer: Running $TARCMD" >&2
115         eval $TARCMD > $DATE.idx
116
117         if [ $? -eq 0 ] && [ -s $TARFILE ]; then
118                 # File is >0 in size and neither cat or tar tzvf failed; we assume it worked.
119
120                 if ! scp root@$computer:$incrementalsnar $SNARFILE.tmp; then
121                         echo `date`" $computer: Could not copy .incremental.snar from $computer"
122                         die
123                 fi
124
125                 # Move tar file in place
126                 mv $TARFILE $DATE.tgz
127                 mv $SNARFILE.tmp $SNARFILE
128
129                 # Update timestamp
130                 echo $DATEs > ../.date && touch -t $DATE ../.date
131
132                 # Make a sorted file list as well
133                 sort -k6 < $DATE.idx > $DATE.sdx
134
135                 # Fix permissions
136                 chmod 600 *tgz                      #only for us
137                 chmod 644 *sdx *idx 2>/dev/null     #everyone can read
138
139                 # Let the remote computer know that we ran a successful backup (for nagios)
140                 ssh root@$computer touch $filesystem/.lastbackup
141         else
142                 # Something wrong happened.
143                 rm $TARFILE
144                 echo `date`" $computer: $TARFILE empty. $backuplevel backup of $computer:$filesystem failed and deleted"
145                 die
146         fi
147 }
148
149 # Check that the target filesystem is mounted (actually check that it's not
150 # the root filesystem)
151 if [ ! -d "$storagedir/$computer" ]; then
152         echo `date`" $computer: Target filesystem ($storagedir/$computer) does not exist. Aborting"
153         die
154 fi
155 rootfilesystem=`df -P /`
156 targetfilesystem=`df -P "$storagedir/$computer"`
157 if [ "$rootfilesystem" == "$targetfilesystem" ]; then
158         echo `date`" $computer: Target filesystem ($storagedir/$computer) was mounted on /. Aborting"
159         die
160 fi
161
162 echo `date`" $computer: Backing up $computer" >&2
163
164 # Try to SSH to the computer without entering a password.
165 if ! `ssh -n -o NumberOfPasswordPrompts=0 root@$computer /bin/true`; then
166         echo `date`" $computer: Could not use passwordless SSH."
167         die
168 fi
169
170 # Check if pigz is available
171 if ssh -n root@$computer "pigz -V 2>/dev/null"; then
172         compressor=pigz
173 else
174         echo `date`" $computer: pigz missing; falling back to gzip."
175         compressor=gzip
176 fi
177
178 # Check dump bit in fstab
179 filesystems=`ssh -n root@$computer "cat /etc/fstab" \
180         | grep -v nfs \
181         | grep -v "^#" \
182         | grep -v "^$" \
183         | awk '{ if ( $(NF-1) != "0" ) print $2}' `
184
185 # Clean up our dir at this client
186 if ! ssh root@$computer "rm -r ~/.backup ; mkdir -m 700 ~/.backup"; then
187         echo `date`" $computer: Could not create backup staging area at $computer:~/.backup"
188         die
189 fi
190
191 # Try to copy $exclude to $computer
192 if ! scp $exclude root@$computer:~/.backup/exclude > /dev/null; then
193         echo `date`" $computer: Could not copy exclude.txt to $computer"
194         die
195 fi
196
197 # Try to copy preeexec and postexec if they exist
198 if [ -f $confdir/preexec.$computer ]; then
199         if ! scp $confdir/preexec.$computer  root@$computer:~/.backup/preexec >&2; then
200                 echo `date`" $computer: Could not copy preexec.$computer to $computer:~/.backup/preexec"
201                 die
202         fi
203 fi
204 if [ -f $confdir/postexec.$computer ]; then
205         if ! scp $confdir/postexec.$computer root@$computer:~/.backup/postexec >&2; then
206                 echo `date`" $computer: Could not copy postexec.$computer to $computer:~/.backup/postexec"
207                 die
208         fi
209 fi
210
211 # Try to run preexec if it exists
212 if ! ssh root@$computer "[ ! -f ~/.backup/preexec ] || /bin/bash -x ~/.backup/preexec" >&2; then
213         echo `date`" $computer: Could not run $computer:~/.backup/preexec"
214         die
215 fi
216
217 for filesystem in $filesystems
218 do
219         # Remove / and $ (for Windows) for path names
220         sfilesystem=`echo $filesystem | tr '\/\$' '__'`
221
222         # Prepare storage area
223         mkdir -m 755 -p $storagedir/$computer/$sfilesystem/full 2>/dev/null
224         mkdir -m 755 -p $storagedir/$computer/$sfilesystem/daglig 2>/dev/null
225
226         # Default backuplevel
227         backuplevel=daglig
228
229         if [ ! -f $storagedir/$computer/$sfilesystem/.date ]
230         then
231                 # Take the first full backup of this filesystem on this computer
232                 backuplevel=full
233                 echo $DATEs > $storagedir/$computer/$sfilesystem/.date
234         fi
235
236         # Check if we want a full backup
237         if [ -f $confdir/fastfullbackupdag.$computer.$sfilesystem ]; then
238                 fullbackup_min_for_this_machine=$dagermellomfulleforfast
239                 if [ "$DAY_OF_MONTH" = "`cat $confdir/fastfullbackupdag.$computer.$sfilesystem`" ]; then
240                         backuplevel=full
241                 fi
242         elif [ -f $confdir/fastfullbackupdag.$computer ]; then
243                 fullbackup_min_for_this_machine=$dagermellomfulleforfast
244                 if [ "$DAY_OF_MONTH" = "`cat $confdir/fastfullbackupdag.$computer`" ]; then
245                         backuplevel=full
246                 fi
247         else
248                 fullbackup_min_for_this_machine=$dagermellomfulle 
249         fi
250
251         if [ -z "`find $storagedir/$computer/$sfilesystem/full/ -name \*tgz -mtime -$fullbackup_min_for_this_machine`" ]; then
252                 backuplevel=full
253         fi
254
255         # We want to be here
256         cd $storagedir/$computer/$sfilesystem/$backuplevel || die
257
258         # Perform the actual backup
259         backup
260
261         # Check if this box has a custom number of full backups
262         if [ -f $confdir/maksfulle.$computer ] ; then
263                 mf=$((`cat $confdir/maksfulle.$computer`+1))
264         else
265                 mf=$(($maksantallfulle+1))
266         fi
267
268         # Delete old full backups
269         for full in `ls -1t $storagedir/$computer/$sfilesystem/full/*tgz | tail -n +$mf`
270         do
271                 prefix=`echo $full | sed "s/\.[^.]*$//"`
272                 echo `date`": $computer:$filesystem Deleting full backup $prefix" >&2
273                 rm $prefix*
274         done
275
276         # Delete incremental backups older than the oldest full backup
277         oldf=`ls -t1 $storagedir/$computer/$sfilesystem/full/*tgz | tail -1`
278         find \
279                 $storagedir/$computer/$sfilesystem/daglig \
280                 -type f \
281                 \! -newer $oldf \
282                 -printf "`date`: $computer: Deleting old incremental backup: %p\n" \
283                 -exec rm {} \; >&2
284 done
285
286 # Try to run postexec if it exist
287 if ! ssh root@$computer "[ ! -f ~/.backup/postexec ] || /bin/bash -x ~/.backup/postexec" >&2; then
288         echo `date`" $computer: Could not run $computer:~/.backup/postexec"
289         die
290 fi
291
292 # Remove lockfile
293 rm $LOCKFILE